//we need the Jeep add-on for this, so force it to load
%error = ForceRequiredAddOn("Vehicle_Jeep");

if(%error == $Error::AddOn_Disabled)
{
   //A bit of a hack:
   //  we just forced the -- to load, but the user had it disabled
   //  so lets make it so they can't select it
   JeepVehicle.uiName = "";
}

if(%error == $Error::AddOn_NotFound)
{
   //we don't have the --, so we're screwed
   error("ERROR: Vehicle_BrickFormula - required add-on Vehicle_Jeep not found");
   return;
}



// BrickFormula_spring.cs

datablock WheeledVehicleSpring(BrickFormulaSpring)
{
   // Wheel suspension properties
   length = 0.35;			 // Suspension travel
   force = 4000; //3000;		 // Spring force
   damping = 900; //600;		 // Spring damping
   antiSwayForce = 3; //3;		 // Lateral anti-sway force
};





// SpeedKart_tire.cs

datablock WheeledVehicleTire(BrickFormulaTire)
{
   // Tires act as springs and generate lateral and longitudinal
   // forces to move the vehicle. These distortion/spring forces
   // are what convert wheel angular velocity into forces that
   // act on the rigid body.
   shapeFile = "./BrickFormulatire.dts";
   
	
	mass = 10;
   radius = 1;
   staticFriction = 5;
   kineticFriction = 5;
   restitution = 0.5;	

   // Spring that generates lateral tire forces
   lateralForce = 6000;
   lateralDamping = 500;
   lateralRelaxation = 0.3;

   // Spring that generates longitudinal tire forces
   longitudinalForce = 5000;
   longitudinalDamping = 2000;
   longitudinalRelaxation = 0.1;
};



// Vehicle //
/////////////
datablock WheeledVehicleData(BrickFormulaVehicle)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./BrickFormula.dts"; //"~/data/shapes/skivehicle.dts"; //
	emap = true;
	minMountDist = 3;
   
   numMountPoints = 1;
   mountThread[0] = "sit";


	maxDamage = 200.00;
	destroyedLevel = 200.00;
	energyPerDamagePoint = 160;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 -0.2 0.2";
   //massBox = "2 5 1";

	maxSteeringAngle = 0.84;  // Maximum steering angle, should match animation
	integration = 4;           // Force integration time: TickSec/Rate
	tireEmitter = VehicleTireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 8;         // Far distance from vehicle
	cameraOffset = 5;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.3;
   collisionTol = 0.1;        // Collision distance tolerance
   contactTol = 0.1;

	useEyePoint = false;	

	defaultTire	= BrickFormulaTire;
	defaultSpring	= BrickFormulaSpring;
	//flatTire	= BrickFormulaFlatTire;
	//flatSpring	= BrickFormulaFlatSpring;

   numWheels = 4;

	// Rigid Body
	mass = 200;
	density = 5.0;
	drag = 4.5;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;        // Impacts over this invoke the script callback
	softImpactSpeed = 10;       // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 12000; //4000;       // Engine power
	engineBrake = 700;         // Braking when throttle is 0
	brakeTorque = 3200;        // When brakes are applied
	maxWheelSpeed = 47;        // Engine scale by current speed / max speed

	rollForce		= 900;
	yawForce		= 600;
	pitchForce		= 1000;
	rotationalDrag		= 0;

   // Advanced Steering
   steeringAutoReturn = true;
   steeringAutoReturnRate = 1;
   steeringAutoReturnMaxSpeed = 10;
   steeringUseStrafeSteering = true;
   steeringStrafeSteeringRate = 0.08;

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

	splash = vehicleSplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = vehicleFoamDropletsEmitter;
	splashEmitter[1] = vehicleFoamEmitter;
	splashEmitter[2] = vehicleBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//   jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	//squealSound = skidSound;
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//   explosion = VehicleExplosion;
	justcollided = 0;

   uiName = "Brick Formula";
	rideable = true;
		lookUpLimit = 0.65;
		lookDownLimit = 0.45;

	paintable = true;
   
   damageEmitter[0] = VehicleBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

   damageEmitter[1] = VehicleBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

   numDmgEmitterAreas = 1;

  

   burnTime = 4000;

   

   minRunOverSpeed    = 4;   //how fast you need to be going to run someone over (do damage)
   runOverDamageScale = 8;   //when you run over someone, speed * runoverdamagescale = damage amt
   runOverPushScale   = 1.2; //how hard a person you're running over gets pushed

   //protection for passengers
   protectPassengersBurn   = false;  //protect passengers from the burning effect of explosions?
   protectPassengersRadius = true;  //protect passengers from radius damage (explosions) ?
   protectPassengersDirect = false; //protect passengers from direct damage (bullets) ?
};


package HugPackage
{
   function armor::onMount(%this,%obj,%col,%slot)
   {
      Parent::onMount(%this,%obj,%col,%slot);
      if(%col.dataBlock $= BrickFormulaVehicle)
         %obj.playThread(2, armReadyBoth);
   }

   function armor::onUnMount(%this,%obj,%col,%slot)
   {
      Parent::onUnMount(%this,%obj,%col,%slot);
      if(%col.dataBlock $= BrickFormulaVehicle)
         %obj.playThread(2, root);
         %obj.playThread(0, root);
   }
};
activatepackage(HugPackage);

function BrickFormulaVehicle::onAdd(%this,%obj)
{
	parent::onadd(%this,%obj);
	   %obj.playthread(0,"propslow");

	TMDesertSmokeCheck(%obj);

	TMDesertSpeedCheck(%this, %obj);

	//mount the nothing tire and ski spring
	%obj.setWheelTire(0, BrickFormulatire);
	%obj.setWheelTire(1, BrickFormulatire);
	%obj.setWheelTire(2, BrickFormulatire);
	%obj.setWheelTire(3, BrickFormulatire);

	%obj.setWheelSpring(0, BrickFormulaSpring);
	%obj.setWheelSpring(1, BrickFormulaSpring);
	%obj.setWheelSpring(2, BrickFormulaSpring);
	%obj.setWheelSpring(3, BrickFormulaSpring);
	
	%obj.setWheelSteering(0,1);
	%obj.setWheelSteering(1,1);
	%obj.setWheelSteering(2,0);
	%obj.setWheelSteering(3,0);
	
	%obj.setWheelPowered(0,false);
	%obj.setWheelPowered(1,false);
	%obj.setWheelPowered(2,true);
	%obj.setWheelPowered(3,true);

	%obj.hideNode(lhand);
	%obj.hideNode(rhand);
	%obj.hideNode(lhook);
	%obj.hideNode(rhook);
}

function BrickFormulavehicle::onDriverLeave(%this,%obj)
{
	%driver = %obj.getControllingObject();
	%obj.hideNode(lhand);
	%obj.hideNode(rhand);
	%obj.hideNode(lhook);
	%obj.hideNode(rhook);
	%driver.client.schedule(0,"applybodyparts");
}

package BrickFormula
{
	function armor::onMount(%this,%obj,%col,%slot)
	{
		Parent::onMount(%this,%obj,%col,%slot);
		if(%col.getDataBlock() == BrickFormulaVehicle.getId())
		{
			%t = %obj.activeThread[1];
			if(!(%t $= "armReadyRight" || %t $= "armReadyBoth"))
			{
				%col.unhideNode($rhand[%obj.client.rhand]);
				%col.setNodeColor($rhand[%obj.client.rhand],%obj.client.rhandcolor);
				%obj.hideNode("rhand");
				%obj.hideNode("rhook");
			}
			if(!(%t $= "armReadyLeft" || %t $= "armReadyBoth"))
			{
				%col.unhideNode($lhand[%obj.client.lhand]);
				%col.setNodeColor($lhand[%obj.client.lhand],%obj.client.lhandcolor);
				%obj.hideNode("lhand");
				%obj.hideNode("lhook");
			}
		}
	}
	function GameConnection::applyBodyParts(%this)
	{
		Parent::applyBodyParts(%this);
		%player = %this.player;
		if(isObject(%player) && isObject(%veh = %player.getObjectMount()) && %veh.getDatablock().getID() == BrickFormulaVehicle.getID())
		{
			%player.hideNode("lhand");
			%player.hideNode("rhand");
			%player.hideNode("lhook");
			%player.hideNode("rhook");
			%veh.hideNode("lhand");
			%veh.hideNode("rhand");
			%veh.hideNode("lhook");
			%veh.hideNode("rhook");
			%veh.unhideNode($lhand[%this.lhand]);
			%veh.unhideNode($rhand[%this.rhand]);
			%veh.setNodeColor($lhand[%this.lhand],%this.lhandColor);
			%veh.setNodeColor($rhand[%this.rhand],%this.rhandColor);
		}
	}
	function Player::playThread(%player,%slot,%thread)
	{
		Parent::playThread(%player,%slot,%thread);
		%veh = %player.getObjectMount();
		%player.activeThread[%slot] = %thread;
		if(isObject(%veh) && %veh.getDatablock().getID() == BrickFormulaVehicle.getID())
		{
			if(%slot == 1)
			{
				if(%thread $= "armReadyRight")
				{
					%veh.hideNode("rhand");
					%veh.hideNode("rhook");
					%player.unHideNode($rhand[%player.client.rhand]);
					%veh.unhideNode($lhand[%player.client.lhand]);
					%veh.setNodeColor($lhand[%player.client.lhand],%player.client.lhandColor);
					%player.hideNode("lhand");
					%player.hideNode("lhook");
				} else if(%thread $= "armReadyLeft")
				{
					%veh.hideNode("lhand");
					%veh.hideNode("lhook");
					%player.unHideNode($lhand[%player.client.lhand]);
					%veh.unhideNode($rhand[%player.client.rhand]);
					%veh.setNodeColor($rhand[%player.client.rhand],%player.client.rhandColor);
					%player.hideNode("rhand");
					%player.hideNode("rhook");
				} else if(%thread $= "armReadyBoth")
				{
					%veh.hideNode("lhand");
					%veh.hideNode("lhook");
					%player.unHideNode($lhand[%player.client.lhand]);
					%veh.hideNode("rhand");
					%veh.hideNode("rhook");
					%player.unHideNode($rhand[%player.client.rhand]);
				} else if(%thread $= "root")
				{
					%player.hideNode("lhand");
					%player.hideNode("rhand");
					%player.hideNode("lhook");
					%player.hideNode("rhook");
					%veh.unhideNode($lhand[%player.client.lhand]);
					%veh.unhideNode($rhand[%player.client.rhand]);
					%veh.setNodeColor($lhand[%player.client.lhand],%player.client.lhandColor);
					%veh.setNodeColor($rhand[%player.client.rhand],%player.client.rhandColor);
				}
			}
		}
	}
};
activatePackage(BrickFormula);